#include "showplayer.h"

QWidget *ShowPlayer::createHeader()
{
    QWidget *ret = new QWidget();

    auto layout = new QHBoxLayout(this);
    QLabel *l = new QLabel("Cue Number");
    layout->addWidget(l);
    l = new QLabel("File Path");
    layout->addWidget(l);
    l = new QLabel("Volume");
    layout->addWidget(l);
    l = new QLabel("Bus 1");
    layout->addWidget(l);
    l = new QLabel("Bus 2");
    layout->addWidget(l);
    l = new QLabel("Pan");
    layout->addWidget(l);
    l = new QLabel("Pitch");
    layout->addWidget(l);
    l = new QLabel("Playback Status");
    layout->addWidget(l);
    l = new QLabel("Fade In");
    layout->addWidget(l);
    l = new QLabel("Fade Out");
    layout->addWidget(l);
    l = new QLabel("Wait In");
    layout->addWidget(l);
    l = new QLabel("Wait Out ");
    layout->addWidget(l);
    l = new QLabel("Halt");
    layout->addWidget(l);
    l = new QLabel("Name");
    layout->addWidget(l);
    l = new QLabel("Notes");
    layout->addWidget(l);
    l = new QLabel("Entry Point");
    layout->addWidget(l);
    l = new QLabel("Exit Point");
    layout->addWidget(l);
    ret->setLayout(layout);
    return ret;
}

ShowPlayer::ShowPlayer(QWidget *parent) :
    QDialog(parent)
  , ui(new Ui::ShowPlayer)
{
    ui->setupUi(this);
    connect(ui->addCueButton, SIGNAL(clicked()), this, SLOT(onAddTrack()));
    connect(ui->goButton, SIGNAL(clicked()), this, SLOT(go()));
    QWidget *w = createHeader();
    ui->headerLayout->addWidget(w);
    currentTrackIndex = 0;
    filesLoaded = 0;
    currentStatus = Status::Iddle;
}

ShowPlayer::~ShowPlayer() {}

void ShowPlayer::onAddTrack() {
	TrackDialog dialog;
    dialog.show();
	if (dialog.exec() == QDialog::Accepted) {
        ui->cueListWidget->addCueTrackWidget(&dialog.track);
	}
}

void ShowPlayer::go()
{
	CueTrackWidget* current = ui->cueListWidget->getTrackAtIndex(currentTrackIndex);
    if (!current)
        return;
    for (int i = 0; i < MAX_LAYERS; i++) {
		if (layersUsed[i] == -1) {
			layersUsed[i] = currentTrackIndex;
			current->audioLayer = i;
			break;
		}
	}
	updateTrackStateInEngine(currentTrackIndex, current->audioLayer);
    emit uiLoadMedia(current->audioLayer, current->getFilePath());
    emit uiPlaybackChanged(current->audioLayer, current->getStatus());
	filesLoaded++;
	currentTrackIndex++;
}
